// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from nao_sensor_msgs:msg/Angle.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__ANGLE__STRUCT_H_
#define NAO_SENSOR_MSGS__MSG__DETAIL__ANGLE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/Angle in the package nao_sensor_msgs.
/**
  * Holds Angle information for a NAO V6
  * Units are in rad
 */
typedef struct nao_sensor_msgs__msg__Angle
{
  /// x axis is rotating Nao left / right (vertical rotation)
  /// - If Nao is facing towards you, rotating it to the left is positive
  /// - Conversely, rotating it to the right is negative
  float x;
  /// y axis is rotating Nao back / forward
  /// - Forward is positive angle
  /// - Backwards is negative angle
  float y;
} nao_sensor_msgs__msg__Angle;

// Struct for a sequence of nao_sensor_msgs__msg__Angle.
typedef struct nao_sensor_msgs__msg__Angle__Sequence
{
  nao_sensor_msgs__msg__Angle * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} nao_sensor_msgs__msg__Angle__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__ANGLE__STRUCT_H_
