// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from nao_sensor_msgs:msg/Angle.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__ANGLE__STRUCT_HPP_
#define NAO_SENSOR_MSGS__MSG__DETAIL__ANGLE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__nao_sensor_msgs__msg__Angle __attribute__((deprecated))
#else
# define DEPRECATED__nao_sensor_msgs__msg__Angle __declspec(deprecated)
#endif

namespace nao_sensor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Angle_
{
  using Type = Angle_<ContainerAllocator>;

  explicit Angle_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->x = 0.0f;
      this->y = 0.0f;
    }
  }

  explicit Angle_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->x = 0.0f;
      this->y = 0.0f;
    }
  }

  // field types and members
  using _x_type =
    float;
  _x_type x;
  using _y_type =
    float;
  _y_type y;

  // setters for named parameter idiom
  Type & set__x(
    const float & _arg)
  {
    this->x = _arg;
    return *this;
  }
  Type & set__y(
    const float & _arg)
  {
    this->y = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    nao_sensor_msgs::msg::Angle_<ContainerAllocator> *;
  using ConstRawPtr =
    const nao_sensor_msgs::msg::Angle_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::Angle_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::Angle_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::Angle_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::Angle_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::Angle_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::Angle_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::Angle_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::Angle_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__nao_sensor_msgs__msg__Angle
    std::shared_ptr<nao_sensor_msgs::msg::Angle_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__nao_sensor_msgs__msg__Angle
    std::shared_ptr<nao_sensor_msgs::msg::Angle_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Angle_ & other) const
  {
    if (this->x != other.x) {
      return false;
    }
    if (this->y != other.y) {
      return false;
    }
    return true;
  }
  bool operator!=(const Angle_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Angle_

// alias to use template instance with default allocator
using Angle =
  nao_sensor_msgs::msg::Angle_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace nao_sensor_msgs

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__ANGLE__STRUCT_HPP_
