﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from nao_sensor_msgs:msg/Battery.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__BATTERY__STRUCT_H_
#define NAO_SENSOR_MSGS__MSG__DETAIL__BATTERY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/Battery in the package nao_sensor_msgs.
typedef struct nao_sensor_msgs__msg__Battery
{
  /// 0% - 100%
  float charge;
  /// True if robot is getting charged
  bool charging;
  /// In Amperes, negative for discharge, positive for charge
  float current;
  /// Celcius (°C)
  float temperature;
} nao_sensor_msgs__msg__Battery;

// Struct for a sequence of nao_sensor_msgs__msg__Battery.
typedef struct nao_sensor_msgs__msg__Battery__Sequence
{
  nao_sensor_msgs__msg__Battery * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} nao_sensor_msgs__msg__Battery__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__BATTERY__STRUCT_H_
