// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from nao_sensor_msgs:msg/Battery.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__BATTERY__TRAITS_HPP_
#define NAO_SENSOR_MSGS__MSG__DETAIL__BATTERY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "nao_sensor_msgs/msg/detail/battery__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace nao_sensor_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Battery & msg,
  std::ostream & out)
{
  out << "{";
  // member: charge
  {
    out << "charge: ";
    rosidl_generator_traits::value_to_yaml(msg.charge, out);
    out << ", ";
  }

  // member: charging
  {
    out << "charging: ";
    rosidl_generator_traits::value_to_yaml(msg.charging, out);
    out << ", ";
  }

  // member: current
  {
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << ", ";
  }

  // member: temperature
  {
    out << "temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Battery & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: charge
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "charge: ";
    rosidl_generator_traits::value_to_yaml(msg.charge, out);
    out << "\n";
  }

  // member: charging
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "charging: ";
    rosidl_generator_traits::value_to_yaml(msg.charging, out);
    out << "\n";
  }

  // member: current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << "\n";
  }

  // member: temperature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Battery & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace nao_sensor_msgs

namespace rosidl_generator_traits
{

[[deprecated("use nao_sensor_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const nao_sensor_msgs::msg::Battery & msg,
  std::ostream & out, size_t indentation = 0)
{
  nao_sensor_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use nao_sensor_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const nao_sensor_msgs::msg::Battery & msg)
{
  return nao_sensor_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<nao_sensor_msgs::msg::Battery>()
{
  return "nao_sensor_msgs::msg::Battery";
}

template<>
inline const char * name<nao_sensor_msgs::msg::Battery>()
{
  return "nao_sensor_msgs/msg/Battery";
}

template<>
struct has_fixed_size<nao_sensor_msgs::msg::Battery>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<nao_sensor_msgs::msg::Battery>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<nao_sensor_msgs::msg::Battery>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__BATTERY__TRAITS_HPP_
