// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from nao_sensor_msgs:msg/Buttons.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__BUTTONS__STRUCT_HPP_
#define NAO_SENSOR_MSGS__MSG__DETAIL__BUTTONS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__nao_sensor_msgs__msg__Buttons __attribute__((deprecated))
#else
# define DEPRECATED__nao_sensor_msgs__msg__Buttons __declspec(deprecated)
#endif

namespace nao_sensor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Buttons_
{
  using Type = Buttons_<ContainerAllocator>;

  explicit Buttons_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->chest = false;
      this->l_foot_bumper_left = false;
      this->l_foot_bumper_right = false;
      this->r_foot_bumper_left = false;
      this->r_foot_bumper_right = false;
    }
  }

  explicit Buttons_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->chest = false;
      this->l_foot_bumper_left = false;
      this->l_foot_bumper_right = false;
      this->r_foot_bumper_left = false;
      this->r_foot_bumper_right = false;
    }
  }

  // field types and members
  using _chest_type =
    bool;
  _chest_type chest;
  using _l_foot_bumper_left_type =
    bool;
  _l_foot_bumper_left_type l_foot_bumper_left;
  using _l_foot_bumper_right_type =
    bool;
  _l_foot_bumper_right_type l_foot_bumper_right;
  using _r_foot_bumper_left_type =
    bool;
  _r_foot_bumper_left_type r_foot_bumper_left;
  using _r_foot_bumper_right_type =
    bool;
  _r_foot_bumper_right_type r_foot_bumper_right;

  // setters for named parameter idiom
  Type & set__chest(
    const bool & _arg)
  {
    this->chest = _arg;
    return *this;
  }
  Type & set__l_foot_bumper_left(
    const bool & _arg)
  {
    this->l_foot_bumper_left = _arg;
    return *this;
  }
  Type & set__l_foot_bumper_right(
    const bool & _arg)
  {
    this->l_foot_bumper_right = _arg;
    return *this;
  }
  Type & set__r_foot_bumper_left(
    const bool & _arg)
  {
    this->r_foot_bumper_left = _arg;
    return *this;
  }
  Type & set__r_foot_bumper_right(
    const bool & _arg)
  {
    this->r_foot_bumper_right = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    nao_sensor_msgs::msg::Buttons_<ContainerAllocator> *;
  using ConstRawPtr =
    const nao_sensor_msgs::msg::Buttons_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::Buttons_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::Buttons_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::Buttons_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::Buttons_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::Buttons_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::Buttons_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::Buttons_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::Buttons_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__nao_sensor_msgs__msg__Buttons
    std::shared_ptr<nao_sensor_msgs::msg::Buttons_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__nao_sensor_msgs__msg__Buttons
    std::shared_ptr<nao_sensor_msgs::msg::Buttons_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Buttons_ & other) const
  {
    if (this->chest != other.chest) {
      return false;
    }
    if (this->l_foot_bumper_left != other.l_foot_bumper_left) {
      return false;
    }
    if (this->l_foot_bumper_right != other.l_foot_bumper_right) {
      return false;
    }
    if (this->r_foot_bumper_left != other.r_foot_bumper_left) {
      return false;
    }
    if (this->r_foot_bumper_right != other.r_foot_bumper_right) {
      return false;
    }
    return true;
  }
  bool operator!=(const Buttons_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Buttons_

// alias to use template instance with default allocator
using Buttons =
  nao_sensor_msgs::msg::Buttons_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace nao_sensor_msgs

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__BUTTONS__STRUCT_HPP_
