// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from nao_sensor_msgs:msg/FSR.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__FSR__STRUCT_H_
#define NAO_SENSOR_MSGS__MSG__DETAIL__FSR__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/FSR in the package nao_sensor_msgs.
/**
  * FSR stands for Force Sensitive Resistors.
  * These sensors measure a resistance change according to the pressure applied.
  * Units used are in Newtons (equivalently kg/m/s^2)
  * http://doc.aldebaran.com/2-1/family/robots/fsr_robot.html
 */
typedef struct nao_sensor_msgs__msg__FSR
{
  float l_foot_front_left;
  float l_foot_front_right;
  float l_foot_back_left;
  float l_foot_back_right;
  float r_foot_front_left;
  float r_foot_front_right;
  float r_foot_back_left;
  float r_foot_back_right;
} nao_sensor_msgs__msg__FSR;

// Struct for a sequence of nao_sensor_msgs__msg__FSR.
typedef struct nao_sensor_msgs__msg__FSR__Sequence
{
  nao_sensor_msgs__msg__FSR * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} nao_sensor_msgs__msg__FSR__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__FSR__STRUCT_H_
