// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from nao_sensor_msgs:msg/FSR.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__FSR__STRUCT_HPP_
#define NAO_SENSOR_MSGS__MSG__DETAIL__FSR__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__nao_sensor_msgs__msg__FSR __attribute__((deprecated))
#else
# define DEPRECATED__nao_sensor_msgs__msg__FSR __declspec(deprecated)
#endif

namespace nao_sensor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FSR_
{
  using Type = FSR_<ContainerAllocator>;

  explicit FSR_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->l_foot_front_left = 0.0f;
      this->l_foot_front_right = 0.0f;
      this->l_foot_back_left = 0.0f;
      this->l_foot_back_right = 0.0f;
      this->r_foot_front_left = 0.0f;
      this->r_foot_front_right = 0.0f;
      this->r_foot_back_left = 0.0f;
      this->r_foot_back_right = 0.0f;
    }
  }

  explicit FSR_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->l_foot_front_left = 0.0f;
      this->l_foot_front_right = 0.0f;
      this->l_foot_back_left = 0.0f;
      this->l_foot_back_right = 0.0f;
      this->r_foot_front_left = 0.0f;
      this->r_foot_front_right = 0.0f;
      this->r_foot_back_left = 0.0f;
      this->r_foot_back_right = 0.0f;
    }
  }

  // field types and members
  using _l_foot_front_left_type =
    float;
  _l_foot_front_left_type l_foot_front_left;
  using _l_foot_front_right_type =
    float;
  _l_foot_front_right_type l_foot_front_right;
  using _l_foot_back_left_type =
    float;
  _l_foot_back_left_type l_foot_back_left;
  using _l_foot_back_right_type =
    float;
  _l_foot_back_right_type l_foot_back_right;
  using _r_foot_front_left_type =
    float;
  _r_foot_front_left_type r_foot_front_left;
  using _r_foot_front_right_type =
    float;
  _r_foot_front_right_type r_foot_front_right;
  using _r_foot_back_left_type =
    float;
  _r_foot_back_left_type r_foot_back_left;
  using _r_foot_back_right_type =
    float;
  _r_foot_back_right_type r_foot_back_right;

  // setters for named parameter idiom
  Type & set__l_foot_front_left(
    const float & _arg)
  {
    this->l_foot_front_left = _arg;
    return *this;
  }
  Type & set__l_foot_front_right(
    const float & _arg)
  {
    this->l_foot_front_right = _arg;
    return *this;
  }
  Type & set__l_foot_back_left(
    const float & _arg)
  {
    this->l_foot_back_left = _arg;
    return *this;
  }
  Type & set__l_foot_back_right(
    const float & _arg)
  {
    this->l_foot_back_right = _arg;
    return *this;
  }
  Type & set__r_foot_front_left(
    const float & _arg)
  {
    this->r_foot_front_left = _arg;
    return *this;
  }
  Type & set__r_foot_front_right(
    const float & _arg)
  {
    this->r_foot_front_right = _arg;
    return *this;
  }
  Type & set__r_foot_back_left(
    const float & _arg)
  {
    this->r_foot_back_left = _arg;
    return *this;
  }
  Type & set__r_foot_back_right(
    const float & _arg)
  {
    this->r_foot_back_right = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    nao_sensor_msgs::msg::FSR_<ContainerAllocator> *;
  using ConstRawPtr =
    const nao_sensor_msgs::msg::FSR_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::FSR_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::FSR_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::FSR_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::FSR_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::FSR_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::FSR_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::FSR_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::FSR_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__nao_sensor_msgs__msg__FSR
    std::shared_ptr<nao_sensor_msgs::msg::FSR_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__nao_sensor_msgs__msg__FSR
    std::shared_ptr<nao_sensor_msgs::msg::FSR_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FSR_ & other) const
  {
    if (this->l_foot_front_left != other.l_foot_front_left) {
      return false;
    }
    if (this->l_foot_front_right != other.l_foot_front_right) {
      return false;
    }
    if (this->l_foot_back_left != other.l_foot_back_left) {
      return false;
    }
    if (this->l_foot_back_right != other.l_foot_back_right) {
      return false;
    }
    if (this->r_foot_front_left != other.r_foot_front_left) {
      return false;
    }
    if (this->r_foot_front_right != other.r_foot_front_right) {
      return false;
    }
    if (this->r_foot_back_left != other.r_foot_back_left) {
      return false;
    }
    if (this->r_foot_back_right != other.r_foot_back_right) {
      return false;
    }
    return true;
  }
  bool operator!=(const FSR_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FSR_

// alias to use template instance with default allocator
using FSR =
  nao_sensor_msgs::msg::FSR_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace nao_sensor_msgs

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__FSR__STRUCT_HPP_
