// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from nao_sensor_msgs:msg/JointCurrents.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_CURRENTS__FUNCTIONS_H_
#define NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_CURRENTS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "nao_sensor_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "nao_sensor_msgs/msg/detail/joint_currents__struct.h"

/// Initialize msg/JointCurrents message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * nao_sensor_msgs__msg__JointCurrents
 * )) before or use
 * nao_sensor_msgs__msg__JointCurrents__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
bool
nao_sensor_msgs__msg__JointCurrents__init(nao_sensor_msgs__msg__JointCurrents * msg);

/// Finalize msg/JointCurrents message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
void
nao_sensor_msgs__msg__JointCurrents__fini(nao_sensor_msgs__msg__JointCurrents * msg);

/// Create msg/JointCurrents message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * nao_sensor_msgs__msg__JointCurrents__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
nao_sensor_msgs__msg__JointCurrents *
nao_sensor_msgs__msg__JointCurrents__create();

/// Destroy msg/JointCurrents message.
/**
 * It calls
 * nao_sensor_msgs__msg__JointCurrents__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
void
nao_sensor_msgs__msg__JointCurrents__destroy(nao_sensor_msgs__msg__JointCurrents * msg);

/// Check for msg/JointCurrents message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
bool
nao_sensor_msgs__msg__JointCurrents__are_equal(const nao_sensor_msgs__msg__JointCurrents * lhs, const nao_sensor_msgs__msg__JointCurrents * rhs);

/// Copy a msg/JointCurrents message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
bool
nao_sensor_msgs__msg__JointCurrents__copy(
  const nao_sensor_msgs__msg__JointCurrents * input,
  nao_sensor_msgs__msg__JointCurrents * output);

/// Initialize array of msg/JointCurrents messages.
/**
 * It allocates the memory for the number of elements and calls
 * nao_sensor_msgs__msg__JointCurrents__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
bool
nao_sensor_msgs__msg__JointCurrents__Sequence__init(nao_sensor_msgs__msg__JointCurrents__Sequence * array, size_t size);

/// Finalize array of msg/JointCurrents messages.
/**
 * It calls
 * nao_sensor_msgs__msg__JointCurrents__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
void
nao_sensor_msgs__msg__JointCurrents__Sequence__fini(nao_sensor_msgs__msg__JointCurrents__Sequence * array);

/// Create array of msg/JointCurrents messages.
/**
 * It allocates the memory for the array and calls
 * nao_sensor_msgs__msg__JointCurrents__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
nao_sensor_msgs__msg__JointCurrents__Sequence *
nao_sensor_msgs__msg__JointCurrents__Sequence__create(size_t size);

/// Destroy array of msg/JointCurrents messages.
/**
 * It calls
 * nao_sensor_msgs__msg__JointCurrents__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
void
nao_sensor_msgs__msg__JointCurrents__Sequence__destroy(nao_sensor_msgs__msg__JointCurrents__Sequence * array);

/// Check for msg/JointCurrents message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
bool
nao_sensor_msgs__msg__JointCurrents__Sequence__are_equal(const nao_sensor_msgs__msg__JointCurrents__Sequence * lhs, const nao_sensor_msgs__msg__JointCurrents__Sequence * rhs);

/// Copy an array of msg/JointCurrents messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_nao_sensor_msgs
bool
nao_sensor_msgs__msg__JointCurrents__Sequence__copy(
  const nao_sensor_msgs__msg__JointCurrents__Sequence * input,
  nao_sensor_msgs__msg__JointCurrents__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_CURRENTS__FUNCTIONS_H_
