// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from nao_sensor_msgs:msg/JointIndexes.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_INDEXES__STRUCT_HPP_
#define NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_INDEXES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__nao_sensor_msgs__msg__JointIndexes __attribute__((deprecated))
#else
# define DEPRECATED__nao_sensor_msgs__msg__JointIndexes __declspec(deprecated)
#endif

namespace nao_sensor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct JointIndexes_
{
  using Type = JointIndexes_<ContainerAllocator>;

  explicit JointIndexes_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit JointIndexes_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations
  static constexpr uint8_t HEADYAW =
    0u;
  static constexpr uint8_t HEADPITCH =
    1u;
  static constexpr uint8_t LSHOULDERPITCH =
    2u;
  static constexpr uint8_t LSHOULDERROLL =
    3u;
  static constexpr uint8_t LELBOWYAW =
    4u;
  static constexpr uint8_t LELBOWROLL =
    5u;
  static constexpr uint8_t LWRISTYAW =
    6u;
  static constexpr uint8_t LHIPYAWPITCH =
    7u;
  static constexpr uint8_t LHIPROLL =
    8u;
  static constexpr uint8_t LHIPPITCH =
    9u;
  static constexpr uint8_t LKNEEPITCH =
    10u;
  static constexpr uint8_t LANKLEPITCH =
    11u;
  static constexpr uint8_t LANKLEROLL =
    12u;
  static constexpr uint8_t RHIPROLL =
    13u;
  static constexpr uint8_t RHIPPITCH =
    14u;
  static constexpr uint8_t RKNEEPITCH =
    15u;
  static constexpr uint8_t RANKLEPITCH =
    16u;
  static constexpr uint8_t RANKLEROLL =
    17u;
  static constexpr uint8_t RSHOULDERPITCH =
    18u;
  static constexpr uint8_t RSHOULDERROLL =
    19u;
  static constexpr uint8_t RELBOWYAW =
    20u;
  static constexpr uint8_t RELBOWROLL =
    21u;
  static constexpr uint8_t RWRISTYAW =
    22u;
  static constexpr uint8_t LHAND =
    23u;
  static constexpr uint8_t RHAND =
    24u;
  static constexpr uint8_t NUMJOINTS =
    25u;

  // pointer types
  using RawPtr =
    nao_sensor_msgs::msg::JointIndexes_<ContainerAllocator> *;
  using ConstRawPtr =
    const nao_sensor_msgs::msg::JointIndexes_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::JointIndexes_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::JointIndexes_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::JointIndexes_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::JointIndexes_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::JointIndexes_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::JointIndexes_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::JointIndexes_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::JointIndexes_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__nao_sensor_msgs__msg__JointIndexes
    std::shared_ptr<nao_sensor_msgs::msg::JointIndexes_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__nao_sensor_msgs__msg__JointIndexes
    std::shared_ptr<nao_sensor_msgs::msg::JointIndexes_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const JointIndexes_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const JointIndexes_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct JointIndexes_

// alias to use template instance with default allocator
using JointIndexes =
  nao_sensor_msgs::msg::JointIndexes_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::HEADYAW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::HEADPITCH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::LSHOULDERPITCH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::LSHOULDERROLL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::LELBOWYAW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::LELBOWROLL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::LWRISTYAW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::LHIPYAWPITCH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::LHIPROLL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::LHIPPITCH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::LKNEEPITCH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::LANKLEPITCH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::LANKLEROLL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::RHIPROLL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::RHIPPITCH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::RKNEEPITCH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::RANKLEPITCH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::RANKLEROLL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::RSHOULDERPITCH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::RSHOULDERROLL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::RELBOWYAW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::RELBOWROLL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::RWRISTYAW;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::LHAND;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::RHAND;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t JointIndexes_<ContainerAllocator>::NUMJOINTS;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace nao_sensor_msgs

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_INDEXES__STRUCT_HPP_
