// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from nao_sensor_msgs:msg/JointPositions.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_POSITIONS__STRUCT_HPP_
#define NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_POSITIONS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__nao_sensor_msgs__msg__JointPositions __attribute__((deprecated))
#else
# define DEPRECATED__nao_sensor_msgs__msg__JointPositions __declspec(deprecated)
#endif

namespace nao_sensor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct JointPositions_
{
  using Type = JointPositions_<ContainerAllocator>;

  explicit JointPositions_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<float, 25>::iterator, float>(this->positions.begin(), this->positions.end(), 0.0f);
    }
  }

  explicit JointPositions_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : positions(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<float, 25>::iterator, float>(this->positions.begin(), this->positions.end(), 0.0f);
    }
  }

  // field types and members
  using _positions_type =
    std::array<float, 25>;
  _positions_type positions;

  // setters for named parameter idiom
  Type & set__positions(
    const std::array<float, 25> & _arg)
  {
    this->positions = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    nao_sensor_msgs::msg::JointPositions_<ContainerAllocator> *;
  using ConstRawPtr =
    const nao_sensor_msgs::msg::JointPositions_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::JointPositions_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::JointPositions_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::JointPositions_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::JointPositions_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::JointPositions_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::JointPositions_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::JointPositions_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::JointPositions_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__nao_sensor_msgs__msg__JointPositions
    std::shared_ptr<nao_sensor_msgs::msg::JointPositions_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__nao_sensor_msgs__msg__JointPositions
    std::shared_ptr<nao_sensor_msgs::msg::JointPositions_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const JointPositions_ & other) const
  {
    if (this->positions != other.positions) {
      return false;
    }
    return true;
  }
  bool operator!=(const JointPositions_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct JointPositions_

// alias to use template instance with default allocator
using JointPositions =
  nao_sensor_msgs::msg::JointPositions_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace nao_sensor_msgs

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_POSITIONS__STRUCT_HPP_
