// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from nao_sensor_msgs:msg/JointStatuses.idl
// generated code does not contain a copyright notice
#include "nao_sensor_msgs/msg/detail/joint_statuses__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
nao_sensor_msgs__msg__JointStatuses__init(nao_sensor_msgs__msg__JointStatuses * msg)
{
  if (!msg) {
    return false;
  }
  // statuses
  return true;
}

void
nao_sensor_msgs__msg__JointStatuses__fini(nao_sensor_msgs__msg__JointStatuses * msg)
{
  if (!msg) {
    return;
  }
  // statuses
}

bool
nao_sensor_msgs__msg__JointStatuses__are_equal(const nao_sensor_msgs__msg__JointStatuses * lhs, const nao_sensor_msgs__msg__JointStatuses * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // statuses
  for (size_t i = 0; i < 25; ++i) {
    if (lhs->statuses[i] != rhs->statuses[i]) {
      return false;
    }
  }
  return true;
}

bool
nao_sensor_msgs__msg__JointStatuses__copy(
  const nao_sensor_msgs__msg__JointStatuses * input,
  nao_sensor_msgs__msg__JointStatuses * output)
{
  if (!input || !output) {
    return false;
  }
  // statuses
  for (size_t i = 0; i < 25; ++i) {
    output->statuses[i] = input->statuses[i];
  }
  return true;
}

nao_sensor_msgs__msg__JointStatuses *
nao_sensor_msgs__msg__JointStatuses__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  nao_sensor_msgs__msg__JointStatuses * msg = (nao_sensor_msgs__msg__JointStatuses *)allocator.allocate(sizeof(nao_sensor_msgs__msg__JointStatuses), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(nao_sensor_msgs__msg__JointStatuses));
  bool success = nao_sensor_msgs__msg__JointStatuses__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
nao_sensor_msgs__msg__JointStatuses__destroy(nao_sensor_msgs__msg__JointStatuses * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    nao_sensor_msgs__msg__JointStatuses__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
nao_sensor_msgs__msg__JointStatuses__Sequence__init(nao_sensor_msgs__msg__JointStatuses__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  nao_sensor_msgs__msg__JointStatuses * data = NULL;

  if (size) {
    data = (nao_sensor_msgs__msg__JointStatuses *)allocator.zero_allocate(size, sizeof(nao_sensor_msgs__msg__JointStatuses), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = nao_sensor_msgs__msg__JointStatuses__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        nao_sensor_msgs__msg__JointStatuses__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
nao_sensor_msgs__msg__JointStatuses__Sequence__fini(nao_sensor_msgs__msg__JointStatuses__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      nao_sensor_msgs__msg__JointStatuses__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

nao_sensor_msgs__msg__JointStatuses__Sequence *
nao_sensor_msgs__msg__JointStatuses__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  nao_sensor_msgs__msg__JointStatuses__Sequence * array = (nao_sensor_msgs__msg__JointStatuses__Sequence *)allocator.allocate(sizeof(nao_sensor_msgs__msg__JointStatuses__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = nao_sensor_msgs__msg__JointStatuses__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
nao_sensor_msgs__msg__JointStatuses__Sequence__destroy(nao_sensor_msgs__msg__JointStatuses__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    nao_sensor_msgs__msg__JointStatuses__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
nao_sensor_msgs__msg__JointStatuses__Sequence__are_equal(const nao_sensor_msgs__msg__JointStatuses__Sequence * lhs, const nao_sensor_msgs__msg__JointStatuses__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!nao_sensor_msgs__msg__JointStatuses__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
nao_sensor_msgs__msg__JointStatuses__Sequence__copy(
  const nao_sensor_msgs__msg__JointStatuses__Sequence * input,
  nao_sensor_msgs__msg__JointStatuses__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(nao_sensor_msgs__msg__JointStatuses);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    nao_sensor_msgs__msg__JointStatuses * data =
      (nao_sensor_msgs__msg__JointStatuses *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!nao_sensor_msgs__msg__JointStatuses__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          nao_sensor_msgs__msg__JointStatuses__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!nao_sensor_msgs__msg__JointStatuses__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
