// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from nao_sensor_msgs:msg/JointStatuses.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_STATUSES__STRUCT_H_
#define NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_STATUSES__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'STATUS_NORMAL'.
/**
  * normal
 */
enum
{
  nao_sensor_msgs__msg__JointStatuses__STATUS_NORMAL = 0l
};

/// Constant 'STATUS_HOT'.
/**
  * high, start to reduce stiffness
 */
enum
{
  nao_sensor_msgs__msg__JointStatuses__STATUS_HOT = 1l
};

/// Constant 'STATUS_VERY_HOT'.
/**
  * very hot, stiffness reduced over 30%
 */
enum
{
  nao_sensor_msgs__msg__JointStatuses__STATUS_VERY_HOT = 2l
};

/// Constant 'STATUS_CRITICALLY_HOT'.
/**
  * critically hot, stiffness is set to 0
 */
enum
{
  nao_sensor_msgs__msg__JointStatuses__STATUS_CRITICALLY_HOT = 3l
};

/// Struct defined in msg/JointStatuses in the package nao_sensor_msgs.
/**
  * Temperature status enums, computed accordingly to the temperature limitation to protect the motors.
 */
typedef struct nao_sensor_msgs__msg__JointStatuses
{
  /// Status codes, in order of JointIndexes.msg
  int32_t statuses[25];
} nao_sensor_msgs__msg__JointStatuses;

// Struct for a sequence of nao_sensor_msgs__msg__JointStatuses.
typedef struct nao_sensor_msgs__msg__JointStatuses__Sequence
{
  nao_sensor_msgs__msg__JointStatuses * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} nao_sensor_msgs__msg__JointStatuses__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_STATUSES__STRUCT_H_
