// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from nao_sensor_msgs:msg/JointStatuses.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_STATUSES__STRUCT_HPP_
#define NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_STATUSES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__nao_sensor_msgs__msg__JointStatuses __attribute__((deprecated))
#else
# define DEPRECATED__nao_sensor_msgs__msg__JointStatuses __declspec(deprecated)
#endif

namespace nao_sensor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct JointStatuses_
{
  using Type = JointStatuses_<ContainerAllocator>;

  explicit JointStatuses_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<int32_t, 25>::iterator, int32_t>(this->statuses.begin(), this->statuses.end(), 0l);
    }
  }

  explicit JointStatuses_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : statuses(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<int32_t, 25>::iterator, int32_t>(this->statuses.begin(), this->statuses.end(), 0l);
    }
  }

  // field types and members
  using _statuses_type =
    std::array<int32_t, 25>;
  _statuses_type statuses;

  // setters for named parameter idiom
  Type & set__statuses(
    const std::array<int32_t, 25> & _arg)
  {
    this->statuses = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t STATUS_NORMAL =
    0;
  static constexpr int32_t STATUS_HOT =
    1;
  static constexpr int32_t STATUS_VERY_HOT =
    2;
  static constexpr int32_t STATUS_CRITICALLY_HOT =
    3;

  // pointer types
  using RawPtr =
    nao_sensor_msgs::msg::JointStatuses_<ContainerAllocator> *;
  using ConstRawPtr =
    const nao_sensor_msgs::msg::JointStatuses_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::JointStatuses_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::JointStatuses_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::JointStatuses_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::JointStatuses_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::JointStatuses_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::JointStatuses_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::JointStatuses_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::JointStatuses_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__nao_sensor_msgs__msg__JointStatuses
    std::shared_ptr<nao_sensor_msgs::msg::JointStatuses_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__nao_sensor_msgs__msg__JointStatuses
    std::shared_ptr<nao_sensor_msgs::msg::JointStatuses_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const JointStatuses_ & other) const
  {
    if (this->statuses != other.statuses) {
      return false;
    }
    return true;
  }
  bool operator!=(const JointStatuses_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct JointStatuses_

// alias to use template instance with default allocator
using JointStatuses =
  nao_sensor_msgs::msg::JointStatuses_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t JointStatuses_<ContainerAllocator>::STATUS_NORMAL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t JointStatuses_<ContainerAllocator>::STATUS_HOT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t JointStatuses_<ContainerAllocator>::STATUS_VERY_HOT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t JointStatuses_<ContainerAllocator>::STATUS_CRITICALLY_HOT;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace nao_sensor_msgs

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__JOINT_STATUSES__STRUCT_HPP_
