// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from nao_sensor_msgs:msg/RobotConfig.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__ROBOT_CONFIG__STRUCT_HPP_
#define NAO_SENSOR_MSGS__MSG__DETAIL__ROBOT_CONFIG__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__nao_sensor_msgs__msg__RobotConfig __attribute__((deprecated))
#else
# define DEPRECATED__nao_sensor_msgs__msg__RobotConfig __declspec(deprecated)
#endif

namespace nao_sensor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RobotConfig_
{
  using Type = RobotConfig_<ContainerAllocator>;

  explicit RobotConfig_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->body_id = "";
      this->body_version = "";
      this->head_id = "";
      this->head_version = "";
    }
  }

  explicit RobotConfig_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : body_id(_alloc),
    body_version(_alloc),
    head_id(_alloc),
    head_version(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->body_id = "";
      this->body_version = "";
      this->head_id = "";
      this->head_version = "";
    }
  }

  // field types and members
  using _body_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _body_id_type body_id;
  using _body_version_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _body_version_type body_version;
  using _head_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _head_id_type head_id;
  using _head_version_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _head_version_type head_version;

  // setters for named parameter idiom
  Type & set__body_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->body_id = _arg;
    return *this;
  }
  Type & set__body_version(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->body_version = _arg;
    return *this;
  }
  Type & set__head_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->head_id = _arg;
    return *this;
  }
  Type & set__head_version(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->head_version = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    nao_sensor_msgs::msg::RobotConfig_<ContainerAllocator> *;
  using ConstRawPtr =
    const nao_sensor_msgs::msg::RobotConfig_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::RobotConfig_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::RobotConfig_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::RobotConfig_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::RobotConfig_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::RobotConfig_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::RobotConfig_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::RobotConfig_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::RobotConfig_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__nao_sensor_msgs__msg__RobotConfig
    std::shared_ptr<nao_sensor_msgs::msg::RobotConfig_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__nao_sensor_msgs__msg__RobotConfig
    std::shared_ptr<nao_sensor_msgs::msg::RobotConfig_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RobotConfig_ & other) const
  {
    if (this->body_id != other.body_id) {
      return false;
    }
    if (this->body_version != other.body_version) {
      return false;
    }
    if (this->head_id != other.head_id) {
      return false;
    }
    if (this->head_version != other.head_version) {
      return false;
    }
    return true;
  }
  bool operator!=(const RobotConfig_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RobotConfig_

// alias to use template instance with default allocator
using RobotConfig =
  nao_sensor_msgs::msg::RobotConfig_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace nao_sensor_msgs

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__ROBOT_CONFIG__STRUCT_HPP_
