// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from nao_sensor_msgs:msg/RobotConfig.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__ROBOT_CONFIG__TRAITS_HPP_
#define NAO_SENSOR_MSGS__MSG__DETAIL__ROBOT_CONFIG__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "nao_sensor_msgs/msg/detail/robot_config__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace nao_sensor_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RobotConfig & msg,
  std::ostream & out)
{
  out << "{";
  // member: body_id
  {
    out << "body_id: ";
    rosidl_generator_traits::value_to_yaml(msg.body_id, out);
    out << ", ";
  }

  // member: body_version
  {
    out << "body_version: ";
    rosidl_generator_traits::value_to_yaml(msg.body_version, out);
    out << ", ";
  }

  // member: head_id
  {
    out << "head_id: ";
    rosidl_generator_traits::value_to_yaml(msg.head_id, out);
    out << ", ";
  }

  // member: head_version
  {
    out << "head_version: ";
    rosidl_generator_traits::value_to_yaml(msg.head_version, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RobotConfig & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: body_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "body_id: ";
    rosidl_generator_traits::value_to_yaml(msg.body_id, out);
    out << "\n";
  }

  // member: body_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "body_version: ";
    rosidl_generator_traits::value_to_yaml(msg.body_version, out);
    out << "\n";
  }

  // member: head_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "head_id: ";
    rosidl_generator_traits::value_to_yaml(msg.head_id, out);
    out << "\n";
  }

  // member: head_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "head_version: ";
    rosidl_generator_traits::value_to_yaml(msg.head_version, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RobotConfig & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace nao_sensor_msgs

namespace rosidl_generator_traits
{

[[deprecated("use nao_sensor_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const nao_sensor_msgs::msg::RobotConfig & msg,
  std::ostream & out, size_t indentation = 0)
{
  nao_sensor_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use nao_sensor_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const nao_sensor_msgs::msg::RobotConfig & msg)
{
  return nao_sensor_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<nao_sensor_msgs::msg::RobotConfig>()
{
  return "nao_sensor_msgs::msg::RobotConfig";
}

template<>
inline const char * name<nao_sensor_msgs::msg::RobotConfig>()
{
  return "nao_sensor_msgs/msg/RobotConfig";
}

template<>
struct has_fixed_size<nao_sensor_msgs::msg::RobotConfig>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<nao_sensor_msgs::msg::RobotConfig>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<nao_sensor_msgs::msg::RobotConfig>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__ROBOT_CONFIG__TRAITS_HPP_
