// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from nao_sensor_msgs:msg/Battery.idl
// generated code does not contain a copyright notice
#include "nao_sensor_msgs/msg/detail/battery__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
nao_sensor_msgs__msg__Battery__init(nao_sensor_msgs__msg__Battery * msg)
{
  if (!msg) {
    return false;
  }
  // charge
  // charging
  // current
  // temperature
  return true;
}

void
nao_sensor_msgs__msg__Battery__fini(nao_sensor_msgs__msg__Battery * msg)
{
  if (!msg) {
    return;
  }
  // charge
  // charging
  // current
  // temperature
}

bool
nao_sensor_msgs__msg__Battery__are_equal(const nao_sensor_msgs__msg__Battery * lhs, const nao_sensor_msgs__msg__Battery * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // charge
  if (lhs->charge != rhs->charge) {
    return false;
  }
  // charging
  if (lhs->charging != rhs->charging) {
    return false;
  }
  // current
  if (lhs->current != rhs->current) {
    return false;
  }
  // temperature
  if (lhs->temperature != rhs->temperature) {
    return false;
  }
  return true;
}

bool
nao_sensor_msgs__msg__Battery__copy(
  const nao_sensor_msgs__msg__Battery * input,
  nao_sensor_msgs__msg__Battery * output)
{
  if (!input || !output) {
    return false;
  }
  // charge
  output->charge = input->charge;
  // charging
  output->charging = input->charging;
  // current
  output->current = input->current;
  // temperature
  output->temperature = input->temperature;
  return true;
}

nao_sensor_msgs__msg__Battery *
nao_sensor_msgs__msg__Battery__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  nao_sensor_msgs__msg__Battery * msg = (nao_sensor_msgs__msg__Battery *)allocator.allocate(sizeof(nao_sensor_msgs__msg__Battery), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(nao_sensor_msgs__msg__Battery));
  bool success = nao_sensor_msgs__msg__Battery__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
nao_sensor_msgs__msg__Battery__destroy(nao_sensor_msgs__msg__Battery * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    nao_sensor_msgs__msg__Battery__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
nao_sensor_msgs__msg__Battery__Sequence__init(nao_sensor_msgs__msg__Battery__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  nao_sensor_msgs__msg__Battery * data = NULL;

  if (size) {
    data = (nao_sensor_msgs__msg__Battery *)allocator.zero_allocate(size, sizeof(nao_sensor_msgs__msg__Battery), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = nao_sensor_msgs__msg__Battery__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        nao_sensor_msgs__msg__Battery__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
nao_sensor_msgs__msg__Battery__Sequence__fini(nao_sensor_msgs__msg__Battery__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      nao_sensor_msgs__msg__Battery__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

nao_sensor_msgs__msg__Battery__Sequence *
nao_sensor_msgs__msg__Battery__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  nao_sensor_msgs__msg__Battery__Sequence * array = (nao_sensor_msgs__msg__Battery__Sequence *)allocator.allocate(sizeof(nao_sensor_msgs__msg__Battery__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = nao_sensor_msgs__msg__Battery__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
nao_sensor_msgs__msg__Battery__Sequence__destroy(nao_sensor_msgs__msg__Battery__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    nao_sensor_msgs__msg__Battery__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
nao_sensor_msgs__msg__Battery__Sequence__are_equal(const nao_sensor_msgs__msg__Battery__Sequence * lhs, const nao_sensor_msgs__msg__Battery__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!nao_sensor_msgs__msg__Battery__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
nao_sensor_msgs__msg__Battery__Sequence__copy(
  const nao_sensor_msgs__msg__Battery__Sequence * input,
  nao_sensor_msgs__msg__Battery__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(nao_sensor_msgs__msg__Battery);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    nao_sensor_msgs__msg__Battery * data =
      (nao_sensor_msgs__msg__Battery *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!nao_sensor_msgs__msg__Battery__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          nao_sensor_msgs__msg__Battery__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!nao_sensor_msgs__msg__Battery__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
