// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from nao_sensor_msgs:msg/Gyroscope.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__GYROSCOPE__TRAITS_HPP_
#define NAO_SENSOR_MSGS__MSG__DETAIL__GYROSCOPE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "nao_sensor_msgs/msg/detail/gyroscope__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace nao_sensor_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Gyroscope & msg,
  std::ostream & out)
{
  out << "{";
  // member: x
  {
    out << "x: ";
    rosidl_generator_traits::value_to_yaml(msg.x, out);
    out << ", ";
  }

  // member: y
  {
    out << "y: ";
    rosidl_generator_traits::value_to_yaml(msg.y, out);
    out << ", ";
  }

  // member: z
  {
    out << "z: ";
    rosidl_generator_traits::value_to_yaml(msg.z, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Gyroscope & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "x: ";
    rosidl_generator_traits::value_to_yaml(msg.x, out);
    out << "\n";
  }

  // member: y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "y: ";
    rosidl_generator_traits::value_to_yaml(msg.y, out);
    out << "\n";
  }

  // member: z
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z: ";
    rosidl_generator_traits::value_to_yaml(msg.z, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Gyroscope & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace nao_sensor_msgs

namespace rosidl_generator_traits
{

[[deprecated("use nao_sensor_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const nao_sensor_msgs::msg::Gyroscope & msg,
  std::ostream & out, size_t indentation = 0)
{
  nao_sensor_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use nao_sensor_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const nao_sensor_msgs::msg::Gyroscope & msg)
{
  return nao_sensor_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<nao_sensor_msgs::msg::Gyroscope>()
{
  return "nao_sensor_msgs::msg::Gyroscope";
}

template<>
inline const char * name<nao_sensor_msgs::msg::Gyroscope>()
{
  return "nao_sensor_msgs/msg/Gyroscope";
}

template<>
struct has_fixed_size<nao_sensor_msgs::msg::Gyroscope>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<nao_sensor_msgs::msg::Gyroscope>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<nao_sensor_msgs::msg::Gyroscope>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__GYROSCOPE__TRAITS_HPP_
