// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from nao_sensor_msgs:msg/Touch.idl
// generated code does not contain a copyright notice

#ifndef NAO_SENSOR_MSGS__MSG__DETAIL__TOUCH__STRUCT_HPP_
#define NAO_SENSOR_MSGS__MSG__DETAIL__TOUCH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__nao_sensor_msgs__msg__Touch __attribute__((deprecated))
#else
# define DEPRECATED__nao_sensor_msgs__msg__Touch __declspec(deprecated)
#endif

namespace nao_sensor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Touch_
{
  using Type = Touch_<ContainerAllocator>;

  explicit Touch_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->head_front = false;
      this->head_middle = false;
      this->head_rear = false;
    }
  }

  explicit Touch_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->head_front = false;
      this->head_middle = false;
      this->head_rear = false;
    }
  }

  // field types and members
  using _head_front_type =
    bool;
  _head_front_type head_front;
  using _head_middle_type =
    bool;
  _head_middle_type head_middle;
  using _head_rear_type =
    bool;
  _head_rear_type head_rear;

  // setters for named parameter idiom
  Type & set__head_front(
    const bool & _arg)
  {
    this->head_front = _arg;
    return *this;
  }
  Type & set__head_middle(
    const bool & _arg)
  {
    this->head_middle = _arg;
    return *this;
  }
  Type & set__head_rear(
    const bool & _arg)
  {
    this->head_rear = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    nao_sensor_msgs::msg::Touch_<ContainerAllocator> *;
  using ConstRawPtr =
    const nao_sensor_msgs::msg::Touch_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::Touch_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<nao_sensor_msgs::msg::Touch_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::Touch_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::Touch_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      nao_sensor_msgs::msg::Touch_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<nao_sensor_msgs::msg::Touch_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::Touch_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<nao_sensor_msgs::msg::Touch_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__nao_sensor_msgs__msg__Touch
    std::shared_ptr<nao_sensor_msgs::msg::Touch_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__nao_sensor_msgs__msg__Touch
    std::shared_ptr<nao_sensor_msgs::msg::Touch_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Touch_ & other) const
  {
    if (this->head_front != other.head_front) {
      return false;
    }
    if (this->head_middle != other.head_middle) {
      return false;
    }
    if (this->head_rear != other.head_rear) {
      return false;
    }
    return true;
  }
  bool operator!=(const Touch_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Touch_

// alias to use template instance with default allocator
using Touch =
  nao_sensor_msgs::msg::Touch_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace nao_sensor_msgs

#endif  // NAO_SENSOR_MSGS__MSG__DETAIL__TOUCH__STRUCT_HPP_
